<?php

if (!defined('IN_DISCUZ') || !defined('IN_ADMINCP')) {
    exit('Access Denied');
}

$sql = <<<EOF

DROP TABLE IF EXISTS `pre_yimen_order`;
CREATE TABLE `pre_yimen_order` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `uid` int(10) NOT NULL COMMENT '订单用户id',
  `order_id` varchar(128) NOT NULL COMMENT '内部订单ID',
  `trade_id` varchar(128) NOT NULL COMMENT '支付平台订单ID',
  `order_name` varchar(64) NOT NULL COMMENT '订单名称',
  `amount` decimal(8,2) NOT NULL COMMENT '订单金额',
  `is_app` tinyint(2) NOT NULL DEFAULT '1' COMMENT '是否是APP支付',
  `type` int(3) NOT NULL COMMENT '订单类型',
  `state` int(3) NOT NULL COMMENT '订单状态:0 待支付 1 已支付 未回调 2 已回调',
  `create_time` varchar(32) NOT NULL,
  `update_time` varchar(32) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB;

DROP TABLE IF EXISTS `pre_yimen_setting`;
CREATE TABLE `pre_yimen_setting` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(32) NOT NULL COMMENT '配置名',
  `value` text NOT NULL COMMENT '配置的值',
  `group` varchar(32) NOT NULL COMMENT '配置所在的组',
  `tip` varchar(128) NOT NULL COMMENT '当前配置提示',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=23;

INSERT INTO `pre_yimen_setting` VALUES (1,'app_qq_login', '1', 'qq_login', 'APP QQ登录开启状态');
INSERT INTO `pre_yimen_setting` VALUES (2,'web_qq_login', '1', 'qq_login', 'Web QQ登录开始状态');
INSERT INTO `pre_yimen_setting` VALUES (3,'qq_appid', '', 'qq_login', 'QQ Web登录APPID');
INSERT INTO `pre_yimen_setting` VALUES (4,'qq_secret', '', 'qq_login', 'QQ Web登录secret');
INSERT INTO `pre_yimen_setting` VALUES (5,'qq_callback', 'http://{domain}/plugin.php?id=yimen_app:login&type=qq', 'qq_login', 'QQ 网页登录回调');
INSERT INTO `pre_yimen_setting` VALUES (6,'app_login', '1', 'app_global', 'APP 登录开启');
INSERT INTO `pre_yimen_setting` VALUES (7,'app_login_hook', 'global', 'app_global', 'APP 登录挂载模式');
INSERT INTO `pre_yimen_setting` VALUES (8,'app_pay_style', '4', 'app_global', 'APP 支付挂载点位置');
INSERT INTO `pre_yimen_setting` VALUES (9,'app_pay_color', '#ff0000', 'app_global', 'APP 支付挂载点颜色');
INSERT INTO `pre_yimen_setting` VALUES (10,'app_pay', '1', 'app_global', 'APP 支付开启');
INSERT INTO `pre_yimen_setting` VALUES (11,'app_login_style', '4', 'app_global', 'APP 登录挂载点位置');
INSERT INTO `pre_yimen_setting` VALUES (12,'app_login_color', '#ff0000', 'app_global', 'APP 登录挂载点颜色');
INSERT INTO `pre_yimen_setting` VALUES (13,'pay_secret_key', '', 'app_global', 'APP支付回调');
INSERT INTO `pre_yimen_setting` VALUES (14,'app_wx_login', '1', 'wx_login', 'APP 微信登录开启状态');
INSERT INTO `pre_yimen_setting` VALUES (15,'web_wx_login', '1', 'wx_login', 'Web 微信登录开始状态');
INSERT INTO `pre_yimen_setting` VALUES (16,'web_wx_appid', '', 'wx_login', '微信web登录APPID');
INSERT INTO `pre_yimen_setting` VALUES (17,'web_wx_secret', '', 'wx_login', '微信web登录secret');
INSERT INTO `pre_yimen_setting` VALUES (18,'app_wx_appid', '', 'wx_login', '微信APP登录APPID');
INSERT INTO `pre_yimen_setting` VALUES (19,'app_wx_secret', '', 'wx_login', '微信APP登录secret');
INSERT INTO `pre_yimen_setting` VALUES (20,'web_wx_callback', 'http://{domain}/plugin.php?id=yimen_app:login&type=wechat', 'wx_login', '微信web登录回调');
INSERT INTO `pre_yimen_setting` VALUES (21,'app_sina_login', '1', 'sina_login', 'APP微博登录开启状态');
INSERT INTO `pre_yimen_setting` VALUES (22,'web_sina_login', '1', 'sina_login', 'Web微博登录开启状态');
INSERT INTO `pre_yimen_setting` VALUES (23,'app_sina_appkey', '', 'sina_login', 'APP微博APPkey');
INSERT INTO `pre_yimen_setting` VALUES (24,'app_sina_secret', '', 'sina_login', 'APP微博AppSceret');
INSERT INTO `pre_yimen_setting` VALUES (25,'web_sina_appkey', '', 'sina_login', 'web微博APPkey');
INSERT INTO `pre_yimen_setting` VALUES (26,'web_sina_secret', '', 'sina_login', 'web微博AppSceret');
INSERT INTO `pre_yimen_setting` VALUES (27,'web_sina_callback', '', 'sina_login', 'web微博登录回调信息');
INSERT INTO `pre_yimen_setting` VALUES (28,'pay_rechange_scale', '1000', 'app_global', '支付充值比例');
INSERT INTO `pre_yimen_setting` VALUES (29, 'wxpay_app', '0', 'wechat_pay', '微信app支付开启');
INSERT INTO `pre_yimen_setting` VALUES (30, 'wxpay_web', '0', 'wechat_pay', '微信Web支付开启');
INSERT INTO `pre_yimen_setting` VALUES (31, 'wx_appid', '', 'wechat_pay', '微信支付appid');
INSERT INTO `pre_yimen_setting` VALUES (32, 'wx_partnerid', '', 'wechat_pay', '微信支付商户id');
INSERT INTO `pre_yimen_setting` VALUES (33, 'wx_key', '', 'wechat_pay', '微信支付密钥');
INSERT INTO `pre_yimen_setting` VALUES (34, 'alipay_app', '0', 'alipay', '支付宝app开启');
INSERT INTO `pre_yimen_setting` VALUES (35, 'alipay_web', '0', 'alipay', '支付宝web开启');
INSERT INTO `pre_yimen_setting` VALUES (36, 'ali_appid', '0', 'alipay', '阿里支付APPid');
INSERT INTO `pre_yimen_setting` VALUES (37, 'ali_public_key', '', 'alipay', '阿里支付公钥');
INSERT INTO `pre_yimen_setting` VALUES (38, 'ali_private_key', '', 'alipay', '阿里支付私钥');


DROP TABLE IF EXISTS `pre_yimen_user`;
CREATE TABLE `pre_yimen_user` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `uid` int(10) DEFAULT NULL COMMENT '用户关联ID',
  `username` varchar(256) NOT NULL COMMENT '用户关联账号',
  `password` varchar(32) NOT NULL COMMENT 'UC中心密码（用户密码）',
  `openid` varchar(64) NOT NULL COMMENT '三方登录唯一标识（微博的UID）',
  `unionid` varchar(64) NOT NULL COMMENT '三方登录共享标识',
  `nick` varchar(16) NOT NULL COMMENT '用户昵称',
  `avatar` varchar(1024) NOT NULL COMMENT '用户头像',
  `email` varchar(32) NOT NULL COMMENT '系统生成邮箱',
  `platform` varchar(16) NOT NULL COMMENT '三方平台标识',
  `state` int(2) NOT NULL DEFAULT '1' COMMENT '用户状态:0 封禁 1正常',
  `create_time` varchar(32) NOT NULL,
  `update_time` varchar(32) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB;

EOF;

runquery($sql);

$finish = true;
