<?php
/*
 * 三方登录模块
 *
 *
 */
if (!defined('IN_DISCUZ')) {
    exit('Access Denied');
}
include 'config/config_ucenter.php';
include "uc_client/client.php";
include "source/function/function_member.php";
include 'function.php';
$request=$_GET;
$type=$request['type'];
$openid='';$unionid='';$nick='';$avatar='';
//获取配置
$setting=C::t('#yimen_app#yimen_setting')->getSetting();
if ($request['is']=='app') {
    //如果在app里面登录
    switch ($type) {
        case 'qq':
            //QQ登录 拿到QQ登录授权信息
            $openid=$request['openid'];
            if (!empty($request['unionid'])) {
                $unionid=$request['unionid'];
            }
            //再去校验和得到acctoken
            $openInfo=sendGet('https://graph.qq.com/oauth2.0/me?access_token='.$request['at'].'&unionid=1');
            $l = strpos($openInfo, "(");
            $r = strrpos($openInfo, ")");
            $openInfo = substr($openInfo, $l + 1, $r - $l -1);
            $openInfo=json_decode($openInfo, true);
            if (isset($openInfo['error']) && $openInfo['error']==100016) {
                showmessage('授权登录已经过期', '/forum.php');
            }
            if (isset($openInfo['unionid'])) {
                $unionid=$openInfo['unionid'];
            }
            $nick=$request['nickname'];
            $avatar=urldecode($request['figureurl']);
            break;
        case 'wechat':
            //微信登录
            $code=$request['code'];
            if (empty($request['openid']) || empty($request['unionid'])) {
                $userInfo=getWechatUserInfo($setting['wx_login']['app_wx_appid'], $setting['wx_login']['app_wx_secret'], $code);
                if (!$userInfo) {
                    showmessage('授权失败，请稍后再试！', '/forum.php');
                }
                $openid=$userInfo['openid'];
                $unionid=$userInfo['unionid'];
                $nick=$userInfo['nick'];
                $avatar=$userInfo['avatar'];
            } else {
                $openid=$request['openid'];
                $unionid=$request['unionid'];
                $nick=$request['nickname'];
                $avatar=urldecode($request['headimgurl']);
            }
            break;
        case 'sina':
            //微博登录
            $accessToken=$request['token'];
            $openid=$request['uid'];
            $unionid=$openid;
            require 'core/sina/saetv2.ex.class.php';
            $sinaClient=new SaeTClientV2($setting['sina_login']['app_sina_appkey'], $setting['sina_login']['app_sina_secret'], $accessToken);
            $userInfo=$sinaClient->show_user_by_id($openid);
            $nick=$userInfo['screen_name'];
            $avatar=$userInfo['profile_image_url'];
            break;
    }
} else {
    //普通网页授权登录
    switch ($type) {
        case 'qq':
            $code=$request['code'];
            if (empty($code)) {
                showmessage('用户取消授权！', '/forum.php');
            }
            $userInfo=getWebQQUserInfo($setting['qq_login']['qq_appid'], $setting['qq_login']['qq_secret'], $code, $setting['qq_login']['qq_callback'], 1);
            if (!$userInfo) {
                showmessage('授权失败，请稍后再试！', getIndex());
            }
            $openid=$userInfo['openid'];
            $unionid=$userInfo['unionid'];
            $nick=$userInfo['nick'];
            $avatar=$userInfo['avatar'];
            break;
        case 'wechat':
            $code=$request['code'];
            if (empty($code)) {
                showmessage('用户取消授权！', '/forum.php');
            }
            $userInfo=getWechatUserInfo($setting['wx_login']['web_wx_appid'], $setting['wx_login']['web_wx_secret'], $code);
            if (!$userInfo) {
                showmessage('授权失败，请稍后再试！', '/forum.php');
            }
            $openid=$userInfo['openid'];
            $unionid=$userInfo['unionid'];
            $nick=$userInfo['nick'];
            $avatar=$userInfo['avatar'];
            break;
        case 'sina':
            //引入微博相关的类
            $code=$request['code'];
            if (empty($code)) {
                showmessage('用户取消授权！', '/forum.php');
            }
            require 'core/sina/saetv2.ex.class.php';
            $sinaOauth=new SaeTOAuthV2($setting['sina_login']['web_sina_appkey'], $setting['sina_login']['web_sina_secret']);
            $accessToken=$sinaOauth->getAccessToken('code', array('code'=>$code,'redirect_uri'=>$setting['sina_login']['web_sina_callback']));
            if (!$accessToken) {
                showmessage('授权失败(3001)，请稍后再试！', '/forum.php');
            }
            $sinaClient=new SaeTClientV2($setting['sina_login']['web_sina_appkey'], $setting['sina_login']['web_sina_secret'], $accessToken);
            $uid=$sinaClient->get_uid();
            $userInfo=$sinaClient->show_user_by_id($uid['uid']);
            $unionid=$userInfo['id'];
            $openid=$userInfo['id'];
            $nick=$userInfo['name'];
            $avatar=$userInfo['userinfo'];
            break;
    }
}
if ($openid !='' || $unionid !='') {
    if ($nick !='') {
        $nick=base64_encode($nick);
    }//解决gbk中文乱码
    toLogin($type, $openid, $unionid, $nick, $avatar);
}
function toLogin($type, $openid, $unionid, $nick, $avatar)
{
    //统一登录接口
    if ($unionid !='') {
        $ret = C::t('#yimen_app#yimen_user')->getByUnionid($unionid, $type);
    } else {
        $ret = C::t('#yimen_app#yimen_user')->getByOpenid($openid, $type);
    }
    if ($ret) {
        if ($ret['state'] !=1) {
            showmessage('当前用户已被封禁', '/forum.php');
        }
        if ($ret['unionid'] == '' && $unionid != '') {
            C::t('#yimen_app#yimen_user')->upUserById($ret['id'], array('unionid' => $unionid));
        }
        if ($avatar !='' && $ret['avatar'] != $avatar) {
            C::t('#yimen_app#yimen_user')->upUserById($ret['id'], array('avatar' => $avatar));
            //更新头像
            getSecond($avatar, $ret['uid'].'_avatar_small.jpg');
            @copy($ret['uid'].'_avatar_small.jpg', 'uc_server/data/avatar/000/00/00/'.$ret['uid'].'_avatar_small.jpg');
            @copy($ret['uid'].'_avatar_small.jpg', 'uc_server/data/avatar/000/00/00/'.$ret['uid'].'_avatar_middle.jpg');
            @copy($ret['uid'].'_avatar_small.jpg', 'uc_server/data/avatar/000/00/00/'.$ret['uid'].'_avatar_big.jpg');
            unlink($ret['uid'].'_avatar_small.jpg');
        }
        uc_user_synlogin($ret['uid']);
        $member = getuserbyuid($ret['uid'], 1);
        $cookietime = 1296000;
        setloginstatus($member, $cookietime);
        C::t('#yimen_app#yimen_user')->upUserById($ret['id'], array('update_time'=>time()));
        showmessage('登录成功', '/forum.php');
    } else {
        //第一次登录
        $username = strtolower(getKey('alpha', 8));
        $password = getKey('alnum', 8);
        $uid = uc_user_register($username, $password, $username . '@yimenapp.com');
        if ($uid > 0) {
            $ins=C::t('#yimen_app#yimen_user')->addUser(array(
                'uid' => $uid,
                'username' => $username,
                'password' => $password,
                'openid' => $openid,
                'unionid' => $unionid,
                'nick' => $nick,
                'avatar' =>$avatar,
                'email' => $username . '@yimenapp.com',
                'platform' => $type,
                'state'=>1,
                'create_time'=>time(),
                'update_time'=>time()
            ));
            if (!$ins) {
                showmessage('登录失败(1001)，请稍后再试！', '/forum.php');
            } else {
                if ($avatar !='') {
                    //更新头像
                    getSecond($avatar, $uid.'_avatar_small.jpg');
                    @copy($uid.'_avatar_small.jpg', 'uc_server/data/avatar/000/00/00/'.$uid.'_avatar_small.jpg');
                    @copy($uid.'_avatar_small.jpg', 'uc_server/data/avatar/000/00/00/'.$uid.'_avatar_middle.jpg');
                    @copy($uid.'_avatar_small.jpg', 'uc_server/data/avatar/000/00/00/'.$uid.'_avatar_big.jpg');
                    unlink($uid.'_avatar_small.jpg');
                }
                $loginUrl ='/member.php?mod=logging&action=login&loginsubmit=yes&infloat=yes&lssubmit=yes&fastloginfield=username&username=' . $username . '&password=' . $password . '&quickforward=yes&handlekey=ls&referer=forum.php';
                header('Location:'.$loginUrl);
                showmessage('登录成功', $loginUrl);
            }
        } else {
            showmessage('登录失败(1002)，请稍后再试！', '/forum.php');
        }
    }
}
